#include <stdio.h>
#define nodos 4
#define infinito 999

extern int TRACE;
extern int YES;
extern int NO;
extern float clocktime;
extern int connectcosts[nodos][nodos];

extern struct rtpkt

 {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int contador;
  int mincost[nodos];    /* min cost to node 0 ... 3 */
  } a;

struct distance_table 
{
  int costs[nodos][nodos];
} dt0;

int min_distancia0[nodos]={infinito,infinito,infinito,infinito};

/* students to write the following two routines, and maybe some others */

/*Función para calcular el mínimo coste*/
int calcula_min0()
{

	int dest, via, cambio = 0; 
	/*Declaramos las variables que vamos a utilizar para los bucles de ordenación e 		inicializamos cambio a 0 para usarlo*/
	
	int mini[4];
/*Creamos un array de 4 unidades*/

/*Hallamos el camino más corto utilizando dos bucles for y comparando los resultados para iterar la próxima vez*/

	for (dest=0; dest<4; dest++) {	
		mini[dest] = dt0.costs[dest][0];
		for (via=1; via<4; via++) {
			if (mini[dest] > dt0.costs[dest][via]) 
				mini[dest] = dt0.costs[dest][via];
		}
		/*Actualizamos el array con la ruta nueva que es más corta*/
		if (mini[dest] != min_distancia0[dest] ) {
			min_distancia0[dest]= mini[dest];
			cambio = 1;
		}
	}
	return cambio;
}

/*Función para enviar a los nodos vecinos*/
void envia_vecinos0()
{
	int dest;
	struct rtpkt packet;

	/*Creamos el paquete que vamos a enviar*/
	packet.sourceid = 0;
	for (dest=0; dest<4; dest++) 
		packet.mincost[dest] = min_distancia0[dest];

	/*Enviamos el paquete a los destino*/
	packet.destid=1;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 0 envia paquete al nodo 1 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);

	packet.destid=2;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 0 envia paquete al nodo 2 cond %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);

	packet.destid=3;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 0 envia paquete al nodo 3 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);

	printf("\n");
}

void rtinit0(void) 
/*Se encarga de iniciar los valores de la matriz de encaminamiento que se encuentra
definida en la estructura dt.0*/

{
	int dest,via;
	printf("En el tiempo t=%.3f, rtinit0() es llamado. \n", clocktime);
	
/*Inicializamos la tabla distancias para escribir los nodos de destino. Dest significa el destino y via significa el nodo vecino próximo*/
	for (dest=0; dest<4; dest++)
		for (via=0; via<4; via++) {
			if (dest==via)
				dt0.costs[dest][via] = connectcosts[0][dest];
			else
				dt0.costs[dest][via] = infinito;
		}
/*Calculamos el camino más corto*/
	for (dest=0; dest<4; dest++) 		
		min_distancia0[dest]=connectcosts[0][dest];
	printdt0(&dt0);			/*Imprimimos la tabla de distancias*/
	tolayer2();
	envia_vecinos0();			
/*Creamos el paquete y llamamos a envia_vecinos para mandar este paquete a los otros nodos*/
}


void rtupdate0(rcvdpkt)
/*Se llamará por parte de la entidad del nivel de enlace cada vez que llegue
al nodo 0 un paquete procedente de alguno de los nodos (adyacentes) de la red, que
será precisamente el que se reciba a través del parámetro de la función (rcvdpkt).

Estos datos deberían estar distribuidos en cada nodo, pero en esta simulación se defininen centralizados y de acceso global por comodidad en la implementación.*/
  struct rtpkt *rcvdpkt;
{
	int dest,via;
	via=rcvdpkt->sourceid;

	printf("En el tiempo t=%.3f, rtupdate0() es llamado, y nodo 0 recibe paquete del nodo %d\n",
		clocktime, via);

	/* Actualizamos la tabla de distancias*/
	for ( dest= 0; dest<4; dest++) {
		dt0.costs[dest][via] = connectcosts[0][via] + rcvdpkt->mincost[dest];
		if (dt0.costs[dest][via] > infinito)
			dt0.costs[dest][via]=infinito;
	}
	printdt0(&dt0);				/*Mostramos la tabla de distancias actual*/
	if (calcula_min0() == 1)	envia_vecinos0();	/*Actualizamos al camino más corto*/

}


printdt0(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D0 |    1     2    3    \n");
  printf("  ----|----------------------------- \n");
  printf("     1|  %3d   %3d   %3d\n",dtptr->costs[1][1],
	 dtptr->costs[1][2],dtptr->costs[1][3]);
  printf("dest 2|  %3d   %3d   %3d\n",dtptr->costs[2][1],
	 dtptr->costs[2][2],dtptr->costs[2][3]);
  printf("     3|  %3d   %3d   %3d\n",dtptr->costs[3][1],
	 dtptr->costs[3][2],dtptr->costs[3][3]);
 
}

linkhandler0(linkid, newcost)   
  int linkid, newcost;

/* Son las funciones que se llaman por  parte del programa principal en  el instante
10.000 y 20.000 de la simulación para representar un cambio de valor en el coste
asociado al enlace entre el nodo 0 y el nodo 1. Por tanto, esta función sólo estará en node0.c y en node1.c*/
	
{
	int oldcost=connectcosts[0][linkid],dest;	

	printf("En el tiempo t=%.3f, linkhandler0() es llamado \n", clocktime);
	connectcosts[0][linkid] = newcost;

	/*Actualización de la tabla de distancias*/
	for (dest=0; dest<4; dest++) {
		dt0.costs[dest][linkid] = dt0.costs[dest][linkid] - oldcost + newcost;
		if (dt0.costs[dest][linkid] > infinito) dt0.costs[dest][linkid] = infinito;
	}

	printdt0(&dt0);			/*Mostramos la tabla de distancias*/
	if (calcula_min0()==1) envia_vecinos0();	/*Actualizamos al camino más corto*/
}
