#include <stdio.h>
#define nodos 4
#define infinito 999

extern int TRACE;
extern int YES;
extern int NO;
extern float clocktime;
extern int connectcosts[nodos][nodos];

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int contador;
  int mincost[nodos];    /* min cost to node 0 ... 3 */
  }a;

struct distance_table 
{
  int costs[nodos][nodos];
} dt2;


/* students to write the following two routines, and maybe some others */
int min_distancia2[nodos]={infinito,infinito,infinito,infinito};

int calcula_min2()
{
	int dest, via, cambio = 0;
	int mini[4];

	for (dest=0; dest<4; dest++) {
		mini[dest] = dt2.costs[dest][0];

		for (via=1; via<4; via++) {
			if (mini[dest] > dt2.costs[dest][via])
				mini[dest] = dt2.costs[dest][via];
		}
		if (mini[dest] != connectcosts[2][dest] ) {
			connectcosts[2][dest] = mini[dest];
			cambio = 1;
		}
	}
	return cambio;
}

void envia_vecinos2()
{
	int dest;
	struct rtpkt packet;
	packet.sourceid = 2;	
	for (dest=0; dest<4; dest++) 
		packet.mincost[dest] = connectcosts[2][dest];
	
	packet.destid=0;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 2 envia paquete al nodo 0 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	packet.destid=1;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 2 envia paquete al nodo 1 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	packet.destid=3;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 0 envia paquete al nodo 3 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	printf("\n");

}

void rtinit2(void) 
{
	int dest,via;
	printf("En el tiempo t=%.3f, rtinit2() es llamado \n", clocktime);

	for (dest=0; dest<4; dest++)
		for (via=0; via<4; via++) {
			if (dest==via)
				dt2.costs[dest][via] = connectcosts[2][dest];
			else
				dt2.costs[dest][via] = infinito;
		}

	for (dest=0; dest<4; dest++)
		min_distancia2[dest]=connectcosts[2][dest];
	printdt2(&dt2);		
	tolayer2();		
	envia_vecinos2();             
	
}


void rtupdate2(rcvdpkt)
  struct rtpkt *rcvdpkt;
{
	int dest,via;
	via=rcvdpkt->sourceid;
	printf("En el tiempo t=%.3f, rtupdate2() es llamado. Nodo 2 recibe paquete del nodo %d\n",
		clocktime, via);

	for ( dest= 0; dest<4; dest++) {
		dt2.costs[dest][via] = connectcosts[2][via] + rcvdpkt->mincost[dest];
		if (dt2.costs[dest][via] > infinito)
			dt2.costs[dest][via]= infinito;
	}

	printdt2(&dt2);			

	if (calcula_min2() == 1)	
		envia_vecinos2();

}



printdt2(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D2 |    0     1     3 \n");
  printf("  ----|----------------------------- \n");
  printf("     0|  %3d   %3d   %3d\n",dtptr->costs[0][0],
	 dtptr->costs[0][1],dtptr->costs[0][3]);
  printf("dest 1|  %3d   %3d   %3d\n",dtptr->costs[1][0],
	 dtptr->costs[1][1],dtptr->costs[1][3]);
  printf("     3|  %3d   %3d   %3d\n",dtptr->costs[3][0],
	 dtptr->costs[3][1],dtptr->costs[3][3]);
 }
